diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureClay.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureClay.java
index 26f5a7f82..2744a41a7 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureClay.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureClay.java
@@ -13,7 +13,11 @@ import java.util.Random;
 //            MathHelper
 
 public class WorldFeatureClay extends WorldFeature
-{	public WorldFeatureClay(int numberOfBlocks) {
+{
+    private int clayBlockId;
+    private int numberOfBlocks;
+    private int generateInId;
+    public WorldFeatureClay(int numberOfBlocks) {
 		this(numberOfBlocks, Blocks.SAND);
 	}
 
@@ -88,8 +92,5 @@ public class WorldFeatureClay extends WorldFeature
         return true;
     }
 
-    private int clayBlockId;
-    private int numberOfBlocks;
-    private int generateInId;
 }
 
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFire.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFire.java
index 20f4e14f8..20762b94b 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFire.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFire.java
@@ -1,6 +1,5 @@
 package net.minecraft.core.world.generate.feature;
 
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 
@@ -24,7 +23,7 @@ public class WorldFeatureFire extends WorldFeature
             int i1 = (x + random.nextInt(8)) - random.nextInt(8);
             int j1 = (y + random.nextInt(4)) - random.nextInt(4);
             int k1 = (z + random.nextInt(8)) - random.nextInt(8);
-            if(world.isAirBlock(i1, j1, k1) && world.getBlockId(i1, j1 - 1, k1) == Blocks.NETHERRACK.id)
+            if(world.isAirBlock(i1, j1, k1) && world.getBlockId(i1, j1 - 1, k1) == Blocks.COBBLE_NETHERRACK.id)
             {
                 world.setBlockWithNotify(i1, j1, k1, Blocks.FIRE.id);
             }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGlowstoneA.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGlowstoneA.java
index 39760661e..172e4e42c 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGlowstoneA.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGlowstoneA.java
@@ -1,6 +1,5 @@
 package net.minecraft.core.world.generate.feature;
 
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 
@@ -23,7 +22,7 @@ public class WorldFeatureGlowstoneA extends WorldFeature
         {
             return false;
         }
-        if(world.getBlockId(x, y + 1, z) != Blocks.NETHERRACK.id)
+        if(world.getBlockId(x, y + 1, z) != Blocks.COBBLE_NETHERRACK.id)
         {
             return false;
         }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGlowstoneB.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGlowstoneB.java
index 5b3f778be..737d4e37e 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGlowstoneB.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureGlowstoneB.java
@@ -1,6 +1,5 @@
 package net.minecraft.core.world.generate.feature;
 
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 
@@ -23,7 +22,7 @@ public class WorldFeatureGlowstoneB extends WorldFeature
         {
             return false;
         }
-        if(world.getBlockId(x, y + 1, z) != Blocks.NETHERRACK.id)
+        if(world.getBlockId(x, y + 1, z) != Blocks.COBBLE_NETHERRACK.id)
         {
             return false;
         }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherLava.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherLava.java
index 252887b3c..1e51a1207 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherLava.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherLava.java
@@ -21,32 +21,32 @@ public class WorldFeatureNetherLava extends WorldFeature
     @Override
 	public boolean place(World world, Random random, int x, int y, int z)
     {
-        if(world.getBlockId(x, y + 1, z) != Blocks.NETHERRACK.id)
+        if(world.getBlockId(x, y + 1, z) != Blocks.COBBLE_NETHERRACK.id)
         {
             return false;
         }
-        if(world.getBlockId(x, y, z) != 0 && world.getBlockId(x, y, z) != Blocks.NETHERRACK.id)
+        if(world.getBlockId(x, y, z) != 0 && world.getBlockId(x, y, z) != Blocks.COBBLE_NETHERRACK.id)
         {
             return false;
         }
         int l = 0;
-        if(world.getBlockId(x - 1, y, z) == Blocks.NETHERRACK.id)
+        if(world.getBlockId(x - 1, y, z) == Blocks.COBBLE_NETHERRACK.id)
         {
             l++;
         }
-        if(world.getBlockId(x + 1, y, z) == Blocks.NETHERRACK.id)
+        if(world.getBlockId(x + 1, y, z) == Blocks.COBBLE_NETHERRACK.id)
         {
             l++;
         }
-        if(world.getBlockId(x, y, z - 1) == Blocks.NETHERRACK.id)
+        if(world.getBlockId(x, y, z - 1) == Blocks.COBBLE_NETHERRACK.id)
         {
             l++;
         }
-        if(world.getBlockId(x, y, z + 1) == Blocks.NETHERRACK.id)
+        if(world.getBlockId(x, y, z + 1) == Blocks.COBBLE_NETHERRACK.id)
         {
             l++;
         }
-        if(world.getBlockId(x, y - 1, z) == Blocks.NETHERRACK.id)
+        if(world.getBlockId(x, y - 1, z) == Blocks.COBBLE_NETHERRACK.id)
         {
             l++;
         }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureOre.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureOre.java
index dcd24662e..bb6220b87 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureOre.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureOre.java
@@ -84,7 +84,7 @@ public class WorldFeatureOre extends WorldFeature
                         	else
                         	{
                         		int id = world.getBlockId(x, y, z);
-                        		if (id == Blocks.STONE.id || id == Blocks.NETHERRACK.id ||
+                        		if (id == Blocks.STONE.id || id == Blocks.COBBLE_NETHERRACK.id ||
                         				id == Blocks.BASALT.id || id == Blocks.LIMESTONE.id ||
                         				id == Blocks.GRANITE.id)
                         		{
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePumice.java b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePumice.java
new file mode 100644
index 000000000..41c0c9f24
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePumice.java
@@ -0,0 +1,88 @@
+package net.minecraft.core.world.generate.feature;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+
+import java.util.Random;
+
+public class WorldFeaturePumice extends WorldFeature{
+    private int numberOfBlocks;
+    private int generateInId;
+    @MethodParametersAnnotation(names = {"numberOfBlocks"})
+    public WorldFeaturePumice(int numberOfBlocks) {
+        this(numberOfBlocks, Blocks.COBBLE_NETHERRACK);
+    }
+
+    @MethodParametersAnnotation(names = {"numberOfBlocks", "block"})
+    public WorldFeaturePumice(int numberOfBlocks, Block block)
+    {
+        this.numberOfBlocks = numberOfBlocks;
+        this.generateInId = block.id;
+    }
+
+    @Override
+    public boolean place(World world, Random random, int x, int y, int z)
+    {
+        if(world.getBlockMaterial(x, y, z) != Material.lava || world.getBlockId(x, y + 1, z) != 0)
+        {
+            return false;
+        }
+        float f = random.nextFloat() * MathHelper.PI;
+        double d = (float)(x + 8) + (MathHelper.sin(f) * (float)numberOfBlocks) / 8F;
+        double d1 = (float)(x + 8) - (MathHelper.sin(f) * (float)numberOfBlocks) / 8F;
+        double d2 = (float)(z + 8) + (MathHelper.cos(f) * (float)numberOfBlocks) / 8F;
+        double d3 = (float)(z + 8) - (MathHelper.cos(f) * (float)numberOfBlocks) / 8F;
+        double d4 = y - random.nextInt(2) + 1;
+        double d5 = y - random.nextInt(2) + 1;
+        for(int l = 0; l <= numberOfBlocks; l++)
+        {
+            double d6 = d + ((d1 - d) * (double)l) / (double)numberOfBlocks;
+            double d7 = d4 + ((d5 - d4) * (double)l) / (double)numberOfBlocks;
+            double d8 = d2 + ((d3 - d2) * (double)l) / (double)numberOfBlocks;
+            double d9 = (random.nextDouble() * (double)numberOfBlocks) / 16D;
+            double d10 = (double)(MathHelper.sin(((float)l * MathHelper.PI) / (float)numberOfBlocks) + 1.0F) * d9 + 1.0D;
+            double d11 = (double)(MathHelper.sin(((float)l * MathHelper.PI) / (float)numberOfBlocks) + 1.0F) * d9 + 1.0D;
+            int i1 = MathHelper.floor(d6 - d10 / 2D);
+            int j1 = MathHelper.floor(d7 - d11 / 2D);
+            int k1 = MathHelper.floor(d8 - d10 / 2D);
+            int l1 = MathHelper.floor(d6 + d10 / 2D);
+            int i2 = MathHelper.floor(d7 + d11 / 2D);
+            int j2 = MathHelper.floor(d8 + d10 / 2D);
+            for(int k2 = i1; k2 <= l1; k2++)
+            {
+                double d12 = (((double)k2 + 0.5D) - d6) / (d10 / 2D);
+                if(d12 * d12 >= 1.0D)
+                {
+                    continue;
+                }
+                for(int l2 = j1; l2 <= i2; l2++)
+                {
+                    double d13 = (((double)l2 + 0.5D) - d7) / (d11 / 2D);
+                    if(d12 * d12 + d13 * d13 >= 1.0D)
+                    {
+                        continue;
+                    }
+                    for(int i3 = k1; i3 <= j2; i3++)
+                    {
+                        double d14 = (((double)i3 + 0.5D) - d8) / (d10 / 2D);
+                        if(d12 * d12 + d13 * d13 + d14 * d14 < 1.0D)
+                        {
+                            if(world.getBlockId(k2, l2, i3) == generateInId)
+                            {
+                                world.setBlock(k2, l2, i3, Blocks.PUMICE_WET.id);
+                            }
+                        }
+                    }
+
+                }
+
+            }
+
+        }
+
+        return true;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java b/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java
index 1fb276125..118103f9a 100644
--- a/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java
+++ b/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java
@@ -22,7 +22,7 @@ public class WorldTypeNether
         return Properties.of(translationKey)
                 .brightnessRamp(getLightRamp())
                 .oceanBlock(Blocks.FLUID_LAVA_STILL)
-                .fillerBlock(Blocks.NETHERRACK)
+                .fillerBlock(Blocks.COBBLE_NETHERRACK)
                 .noClouds()
                 .noSky()
                 .withCeiling()
